// GetDriveTypeExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetDriveTypeExplorer.h"
#include "GetDriveTypeExplorerDlg.h"
#include "GetDriveType.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetDriveTypeExplorerDlg dialog

CGetDriveTypeExplorerDlg::CGetDriveTypeExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetDriveTypeExplorerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetDriveTypeExplorerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetDriveTypeExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetDriveTypeExplorerDlg)
	DDX_Control(pDX, IDC_ABOUT, c_About);
	DDX_Control(pDX, IDC_RESULT2, c_Result2);
	DDX_Control(pDX, IDC_SPLIT, c_Split);
	DDX_Control(pDX, IDC_RESULT, c_Result);
	DDX_Control(pDX, IDC_PATH, c_Path);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGetDriveTypeExplorerDlg, CDialog)
	//{{AFX_MSG_MAP(CGetDriveTypeExplorerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_PATH, OnChangePath)
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetDriveTypeExplorerDlg message handlers

BOOL CGetDriveTypeExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

 	HICON icon = AfxGetApp()->LoadIcon(IDI_JMNCO);
	c_About.SetIcon(icon);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGetDriveTypeExplorerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CGetDriveTypeExplorerDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetDriveTypeExplorerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetDriveTypeExplorerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/****************************************************************************
*                              driveTypeToString
* Inputs:
*       UINT type: Type of drive
* Result: CString
*       String value
* Effect: 
*       
****************************************************************************/

CString driveTypeToString(UINT type)
    {
     CString s;
     switch(type)
	{ /* decode */
	 case DRIVE_UNKNOWN:
		 s.LoadString(IDS_DRIVE_UNKNOWN);
		 break;
	 case DRIVE_NO_ROOT_DIR:
		 s.LoadString(IDS_DRIVE_NO_ROOT_DIR);
		 break;
	 case DRIVE_REMOVABLE:
		 s.LoadString(IDS_DRIVE_REMOVABLE);
		 break;
	 case DRIVE_FIXED:
		 s.LoadString(IDS_DRIVE_FIXED);
		 break;
	 case DRIVE_REMOTE:
		 s.LoadString(IDS_DRIVE_REMOTE);
		 break;
	 case IDS_DRIVE_CDROM:
		 s.LoadString(IDS_DRIVE_CDROM);
		 break;
	 case IDS_DRIVE_RAMDISK:
		 s.LoadString(IDS_DRIVE_RAMDISK);
		 break;
	 default:
		 s.LoadString(IDS_ERROR);
		 break;
	} /* decode */
     return s;
    }

void CGetDriveTypeExplorerDlg::OnChangePath() 
{
 CString s;
 CString name;
 c_Path.GetWindowText(name);
 s = driveTypeToString(GetDriveType(name));

 c_Result.SetWindowText(s);

 char drv[_MAX_PATH];
 char path[_MAX_PATH];
 char filename[_MAX_PATH];
 char ext[_MAX_PATH];

 _splitpath(name, drv, path, filename, ext);
 s.Format("[%s] [%s] [%s] [%s]", drv, path, filename, ext);
 c_Split.SetWindowText(s);

 s = driveTypeToString(getDriveType(name));
 c_Result2.SetWindowText(s);
}

void CGetDriveTypeExplorerDlg::OnAbout() 
    {
     CAboutDlg dlgAbout;
     dlgAbout.DoModal();
    }
